package flink.zanxiangnet.ad.monitoring.util;

import org.apache.commons.lang3.StringUtils;
import org.springframework.util.CollectionUtils;

import java.util.*;
import java.util.stream.Collectors;

public class PlanUtil {
    public static Set<Long> parseAdStr(String adIdsStr) {
        if (StringUtils.isBlank(adIdsStr)) {
            return new HashSet<>(3);
        }
        return Arrays.stream(adIdsStr.split(",")).map(Long::valueOf).collect(Collectors.toSet());
    }

    public static Map<Long, List<Long>> parseAdGroupMapStr(String adGroupMapStr) {
        if (StringUtils.isBlank(adGroupMapStr)) {
            return new HashMap<>(2);
        }
        Map<Long, List> mapTemp = JsonUtil.toMap(adGroupMapStr, Map.class, Long.class, List.class);
        Map<Long, List<Long>> adGroupMap = new HashMap<>(mapTemp.size());
        mapTemp.forEach((key, value) -> {
            List<Long> temp = new ArrayList<>(value.size());
            value.forEach(adId -> temp.add(ObjectUtil.toLong(adId)));
            adGroupMap.put(key, temp);
        });
        return adGroupMap;
    }

    public static String adIdsStr(Set<Long> adIds) {
        if (CollectionUtils.isEmpty(adIds)) {
            return null;
        }
        return StringUtils.join(adIds, ",");
    }

    public static String adIdsStr(Long adId) {
        return String.valueOf(adId);
    }

    public static String adGroupMapStr(Map<Long, List<Long>> adGroupIds) {
        if (adGroupIds == null || adGroupIds.isEmpty()) {
            return null;
        }
        return JsonUtil.toString(adGroupIds);
    }
}
